/* Tabela PARAMPLANEJA: Parmetros do Planejamento */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela PARAMPLANEJA */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela PARAMPLANEJA,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_PLA_PARAMPLANEJA
AFTER DELETE OR INSERT OR UPDATE
ON PARAMPLANEJA FOR EACH ROW
DECLARE
  V_USUARIO    VARCHAR2(40);
  V_TIPO       VARCHAR2(1);
  V_ITPESQ     VARCHAR2(40);
  V_DESC       VARCHAR2(1000);
  V_DTOPER     DATE;
  V_DSIP       VARCHAR2(50);
  V_DSUSUARIO  VARCHAR2(50);
  V_DSRDM      VARCHAR2(50);
  V_DSMETODO   VARCHAR2(250);
  V_DSOPERADOR VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   WEBTUNNING(V_DSIP,
              V_DSUSUARIO,
              V_DSRDM,
              V_DSMETODO,
              V_DSOPERADOR);
   IF DELETING THEN
      V_DESC := 'Fili=' || :OLD.CDFILIAL;
      V_DESC := V_DESC || ' Rdm='     || V_DSRDM;
      V_DESC := V_DESC || ' Mtodo='  || V_DSMETODO;
      V_DESC := V_DESC || ' Ip='      || V_DSIP;
      V_DESC := V_DESC || ' Usurio=' || V_DSUSUARIO;
      V_DESC := V_DESC || ' Operador='|| V_DSOPERADOR;
      V_TIPO := '3';
      V_ITPESQ := :OLD.CDFILIAL;
   ELSE
      IF UPDATING THEN
         IF (:OLD.CDFILIAL <> :NEW.CDFILIAL) OR
            (NVL(:OLD.CDNUTRRELAT1, '') <> NVL(:NEW.CDNUTRRELAT1, '')) OR
            (NVL(:OLD.CDNUTRRELAT2, '') <> NVL(:NEW.CDNUTRRELAT2, '')) OR
            (NVL(:OLD.TXLAYOUTCATR, '') <> NVL(:NEW.TXLAYOUTCATR, '')) OR
            (NVL(:OLD.IDUTREQUPRAT, '') <> NVL(:NEW.IDUTREQUPRAT, '')) OR
            (NVL(:OLD.IDBLPRCUSZER, '') <> NVL(:NEW.IDBLPRCUSZER, '')) OR
            (NVL(:OLD.IDCARDIAUTIL, '') <> NVL(:NEW.IDCARDIAUTIL, '')) OR
            (NVL(:OLD.IDAPRERECE,   '') <> NVL(:NEW.IDAPRERECE,   '')) OR
            (NVL(:OLD.IDGANHOCOCC,  '') <> NVL(:NEW.IDGANHOCOCC,  '')) OR
            (NVL(:OLD.IDAPROVCOCC,  '') <> NVL(:NEW.IDAPROVCOCC,  '')) OR
            (NVL(:OLD.IDPERDALIMP,  '') <> NVL(:NEW.IDPERDALIMP,  '')) OR
            (NVL(:OLD.IDAPROVLIMP,  '') <> NVL(:NEW.IDAPROVLIMP,  '')) OR
            (NVL(:OLD.IDTEMPPREP,   '') <> NVL(:NEW.IDTEMPPREP,   '')) OR
            (NVL(:OLD.IDCONSGRPRAT, '') <> NVL(:NEW.IDCONSGRPRAT, '')) OR
            (NVL(:OLD.IDQTLIQUBRUT, '') <> NVL(:NEW.IDQTLIQUBRUT, '')) OR
            (NVL(:OLD.IDCUSPADCAR,  '') <> NVL(:NEW.IDCUSPADCAR,  '')) OR
            (NVL(:OLD.IDRESTRCARD,  '') <> NVL(:NEW.IDRESTRCARD,  '')) OR
            (NVL(:OLD.IDEFETCARDIA, '') <> NVL(:NEW.IDEFETCARDIA, '')) OR
            (NVL(:OLD.IDSOMACOMEST, '') <> NVL(:NEW.IDSOMACOMEST, '')) OR
            (NVL(:OLD.IDACOMPCUSTO, '') <> NVL(:NEW.IDACOMPCUSTO, '')) OR
            (NVL(:OLD.IDCALPADCMP,  '') <> NVL(:NEW.IDCALPADCMP,  '')) OR
            (NVL(:OLD.CDTPCUSTCMP,  '') <> NVL(:NEW.CDTPCUSTCMP,  '')) OR
            (NVL(:OLD.IDCARDIFRETI, '') <> NVL(:NEW.IDCARDIFRETI, '')) OR
            (NVL(:OLD.CDTPRETIPADR, '') <> NVL(:NEW.CDTPRETIPADR, '')) OR
            (NVL(:OLD.CDTPRCONSFIX, '') <> NVL(:NEW.CDTPRCONSFIX, '')) OR
            (NVL(:OLD.CDFILCONSFIX, '') <> NVL(:NEW.CDFILCONSFIX, '')) OR
            (NVL(:OLD.CDPRACONSFIX, '') <> NVL(:NEW.CDPRACONSFIX, '')) OR
            (NVL(:OLD.CDTPRCONSPER, '') <> NVL(:NEW.CDTPRCONSPER, '')) OR
            (NVL(:OLD.CDFILCONSPER, '') <> NVL(:NEW.CDFILCONSPER, '')) OR
            (NVL(:OLD.CDPRACONSPER, '') <> NVL(:NEW.CDPRACONSPER, '')) OR
            (NVL(:OLD.IDVISUAQTEST, '') <> NVL(:NEW.IDVISUAQTEST, '')) OR
            (NVL(:OLD.IDPERCCOME,   '') <> NVL(:NEW.IDPERCCOME,   '')) OR
            (NVL(:OLD.VRINDCALCMP,   -1) <> NVL(:NEW.VRINDCALCMP,   -1)) OR
            (NVL(:OLD.NRCORSAFRA,    -1) <> NVL(:NEW.NRCORSAFRA,    -1)) OR
            (NVL(:OLD.NRCORINICSAF,  -1) <> NVL(:NEW.NRCORINICSAF,  -1)) OR
            (NVL(:OLD.NRCORENTRSAF,  -1) <> NVL(:NEW.NRCORENTRSAF,  -1)) OR
            (NVL(:OLD.NRCORNUTIL,    -1) <> NVL(:NEW.NRCORNUTIL,    -1)) OR
            (NVL(:OLD.NRCORNALTE,    -1) <> NVL(:NEW.NRCORNALTE,    -1)) THEN
            V_TIPO   := '2';
            V_ITPESQ := :OLD.CDFILIAL;
         END IF;
      ELSE
         V_TIPO   := '1';
         V_ITPESQ := :NEW.CDFILIAL;
      END IF;
      IF UPDATING THEN
         IF (:OLD.CDFILIAL <> :NEW.CDFILIAL) THEN
            V_DESC := V_DESC || 'Fili=' || :OLD.CDFILIAL || '|' || :NEW.CDFILIAL;
         ELSE
            V_DESC := V_DESC || 'Fili=' || :OLD.CDFILIAL;
         END IF;
      ELSE
         V_DESC := V_DESC || 'Fili=' || :NEW.CDFILIAL;
      END IF;
      IF (NVL(:OLD.IDBLPRCUSZER, '') <> NVL(:NEW.IDBLPRCUSZER, '')) OR
         (NVL(:OLD.IDCARDIAUTIL, '') <> NVL(:NEW.IDCARDIAUTIL, '')) OR
         (NVL(:OLD.IDCONSGRPRAT, '') <> NVL(:NEW.IDCONSGRPRAT, '')) OR
         (NVL(:OLD.IDCUSPADCAR,  '') <> NVL(:NEW.IDCUSPADCAR,  '')) OR
         (NVL(:OLD.IDRESTRCARD,  '') <> NVL(:NEW.IDRESTRCARD,  '')) OR
         (NVL(:OLD.IDSOMACOMEST, '') <> NVL(:NEW.IDSOMACOMEST, '')) OR
         (NVL(:OLD.IDACOMPCUSTO, '') <> NVL(:NEW.IDACOMPCUSTO, '')) OR
         (NVL(:OLD.IDCARDIFRETI, '') <> NVL(:NEW.IDCARDIFRETI, '')) THEN
         V_DESC := V_DESC || ' Planej:';
      END IF;   
      IF (NVL(:NEW.IDBLPRCUSZER, '') <> '') OR (UPDATING AND (NVL(:NEW.IDBLPRCUSZER, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.IDBLPRCUSZER, '') <> NVL(:NEW.IDBLPRCUSZER, '')) THEN
               V_DESC := V_DESC || ' CustZerRec=' || :OLD.IDBLPRCUSZER || '|' || :NEW.IDBLPRCUSZER;
            END IF;
         ELSE
            V_DESC := V_DESC || ' CustZerRec=' || :NEW.IDBLPRCUSZER;
         END IF;
      END IF;
      IF (NVL(:NEW.IDCARDIAUTIL, '') <> '') OR (UPDATING AND (NVL(:NEW.IDCARDIAUTIL, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.IDCARDIAUTIL, '') <> NVL(:NEW.IDCARDIAUTIL, '')) THEN
               V_DESC := V_DESC || ' BloqDiaNUtiL=' || :OLD.IDCARDIAUTIL || '|' || :NEW.IDCARDIAUTIL;
            END IF;
         ELSE
            V_DESC := V_DESC || ' BloqDiaNUtiL=' || :NEW.IDCARDIAUTIL;
         END IF;
      END IF;
      IF (NVL(:NEW.IDCONSGRPRAT, '') <> '') OR (UPDATING AND (NVL(:NEW.IDCONSGRPRAT, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.IDCONSGRPRAT, '') <> NVL(:NEW.IDCONSGRPRAT, '')) THEN
               V_DESC := V_DESC || ' PesqGrupPrat=' || :OLD.IDCONSGRPRAT || '|' || :NEW.IDCONSGRPRAT;
            END IF;
         ELSE
            V_DESC := V_DESC || ' PesqGrupPrat=' || :NEW.IDCONSGRPRAT;
         END IF;
      END IF;
      IF (NVL(:NEW.IDCUSPADCAR, '') <> '') OR (UPDATING AND (NVL(:NEW.IDCUSPADCAR, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.IDCUSPADCAR, '') <> NVL(:NEW.IDCUSPADCAR, '')) THEN
               V_DESC := V_DESC || ' CustPadrCar=' || :OLD.IDCUSPADCAR || '|' || :NEW.IDCUSPADCAR;
            END IF;
         ELSE
            V_DESC := V_DESC || ' CustPadrCar=' || :NEW.IDCUSPADCAR;
         END IF;
      END IF;
      IF (NVL(:NEW.IDRESTRCARD, '') <> '') OR (UPDATING AND (NVL(:NEW.IDRESTRCARD, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.IDRESTRCARD, '') <> NVL(:NEW.IDRESTRCARD, '')) THEN
               V_DESC := V_DESC || ' VerifRestCar=' || :OLD.IDRESTRCARD || '|' || :NEW.IDRESTRCARD;
            END IF;
         ELSE
            V_DESC := V_DESC || ' VerifRestCar=' || :NEW.IDRESTRCARD;
         END IF;
      END IF;
      IF (NVL(:NEW.IDSOMACOMEST, '') <> '') OR (UPDATING AND (NVL(:NEW.IDSOMACOMEST, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.IDSOMACOMEST, '') <> NVL(:NEW.IDSOMACOMEST, '')) THEN
               V_DESC := V_DESC || ' SomaNOpc=' || :OLD.IDSOMACOMEST || '|' || :NEW.IDSOMACOMEST;
            END IF;
         ELSE
            V_DESC := V_DESC || ' SomaNOpc=' || :NEW.IDSOMACOMEST;
         END IF;
      END IF;
      IF (NVL(:NEW.IDACOMPCUSTO, '') <> '') OR (UPDATING AND (NVL(:NEW.IDACOMPCUSTO, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.IDACOMPCUSTO, '') <> NVL(:NEW.IDACOMPCUSTO, '')) THEN
               V_DESC := V_DESC || ' VerifCustCar=' || :OLD.IDACOMPCUSTO || '|' || :NEW.IDACOMPCUSTO;
            END IF;
         ELSE
            V_DESC := V_DESC || ' VerifCustCar=' || :NEW.IDACOMPCUSTO;
         END IF;
      END IF;
      IF (NVL(:NEW.IDCARDIFRETI, '') <> '') OR (UPDATING AND (NVL(:NEW.IDCARDIFRETI, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.IDCARDIFRETI, '') <> NVL(:NEW.IDCARDIFRETI, '')) THEN
               V_DESC := V_DESC || ' DtCar<>DtRet=' || :OLD.IDCARDIFRETI || '|' || :NEW.IDCARDIFRETI;
            END IF;
         ELSE
            V_DESC := V_DESC || ' DtCar<>DtRet=' || :NEW.IDCARDIFRETI;
         END IF;
      END IF;
      IF (NVL(:OLD.CDNUTRRELAT1, '') <> NVL(:NEW.CDNUTRRELAT1, '')) OR 
         (NVL(:OLD.CDNUTRRELAT2, '') <> NVL(:NEW.CDNUTRRELAT2, '')) THEN
         V_DESC := V_DESC || ' NutRel:';
      END IF; 
      IF (NVL(:NEW.CDNUTRRELAT1, '') <> '') OR (UPDATING AND (NVL(:NEW.CDNUTRRELAT1, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.CDNUTRRELAT1, '') <> NVL(:NEW.CDNUTRRELAT1, '')) THEN
               V_DESC := V_DESC || ' 1Nut=' || :OLD.CDNUTRRELAT1 || '|' || :NEW.CDNUTRRELAT1;
            END IF;
         ELSE
            V_DESC := V_DESC || ' 1Nut=' || :NEW.CDNUTRRELAT1;
         END IF;
      END IF;
      IF (NVL(:NEW.CDNUTRRELAT2, '') <> '') OR (UPDATING AND (NVL(:NEW.CDNUTRRELAT2, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.CDNUTRRELAT2, '') <> NVL(:NEW.CDNUTRRELAT2, '')) THEN
               V_DESC := V_DESC || ' 2Nut=' || :OLD.CDNUTRRELAT2 || '|' || :NEW.CDNUTRRELAT2;
            END IF;
         ELSE
            V_DESC := V_DESC || ' 2Nut=' || :NEW.CDNUTRRELAT2;
         END IF;
      END IF;
      IF (NVL(:OLD.IDCALPADCMP, '') <> NVL(:NEW.IDCALPADCMP, '')) OR
         (NVL(:OLD.CDTPCUSTCMP, '') <> NVL(:NEW.CDTPCUSTCMP, '')) OR
         (NVL(:OLD.VRINDCALCMP,  -1) <> NVL(:NEW.VRINDCALCMP,  -1)) THEN
         V_DESC := V_DESC || ' NecComp:';
      END IF;  
      IF (NVL(:NEW.IDCALPADCMP, '') <> '') OR (UPDATING AND (NVL(:NEW.IDCALPADCMP, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.IDCALPADCMP, '') <> NVL(:NEW.IDCALPADCMP, '')) THEN
               V_DESC := V_DESC || ' VerifCustPad=' || :OLD.IDCALPADCMP || '|' || :NEW.IDCALPADCMP;
            END IF;
         ELSE
            V_DESC := V_DESC || ' VerifCustPad=' || :NEW.IDCALPADCMP;
         END IF;
      END IF;
      IF (NVL(:NEW.CDTPCUSTCMP, '') <> '') OR (UPDATING AND (NVL(:NEW.CDTPCUSTCMP, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.CDTPCUSTCMP, '') <> NVL(:NEW.CDTPCUSTCMP, '')) THEN
               V_DESC := V_DESC || ' TipCust=' || :OLD.CDTPCUSTCMP || '|' || :NEW.CDTPCUSTCMP;
            END IF;
         ELSE
            V_DESC := V_DESC || ' TipCust=' || :NEW.CDTPCUSTCMP;
         END IF;
      END IF;
      IF (NVL(:NEW.VRINDCALCMP, -1) <> -1) OR (UPDATING AND (NVL(:NEW.VRINDCALCMP, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.VRINDCALCMP, -1) <> NVL(:NEW.VRINDCALCMP, -1)) THEN
               V_DESC := V_DESC || ' Ind=' || :OLD.VRINDCALCMP || '|' || :NEW.VRINDCALCMP;
            END IF;
         ELSE
            V_DESC := V_DESC || ' Ind' || :NEW.VRINDCALCMP;
         END IF;
      END IF;
      IF (NVL(:OLD.IDVISUAQTEST, '') <> NVL(:NEW.IDVISUAQTEST, '')) THEN
         V_DESC := V_DESC || ' RetiEst:';
      END IF;
      IF (NVL(:NEW.IDVISUAQTEST, '') <> '') OR (UPDATING AND (NVL(:NEW.IDVISUAQTEST, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.IDVISUAQTEST, '') <> NVL(:NEW.IDVISUAQTEST, '')) THEN
               V_DESC := V_DESC || ' SaldEst=' || :OLD.IDVISUAQTEST || '|' || :NEW.IDVISUAQTEST;
            END IF;
         ELSE
            V_DESC := V_DESC || ' SaldEst=' || :NEW.IDVISUAQTEST;
         END IF;
      END IF;
      IF (NVL(:NEW.CDTPRETIPADR, '') <> '') OR (UPDATING AND (NVL(:NEW.CDTPRETIPADR, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.CDTPRETIPADR, '') <> NVL(:NEW.CDTPRETIPADR, '')) THEN
               V_DESC := V_DESC || ' TipRetDef=' || :OLD.CDTPRETIPADR || '|' || :NEW.CDTPRETIPADR;
            END IF;
         ELSE
            V_DESC := V_DESC || ' TipRetDef=' || :NEW.CDTPRETIPADR;
         END IF;
      END IF; 
      IF (NVL(:OLD.NRCORINICSAF, -1) <> NVL(:NEW.NRCORINICSAF, -1)) OR
         (NVL(:OLD.NRCORENTRSAF, -1) <> NVL(:NEW.NRCORENTRSAF, -1)) OR
         (NVL(:OLD.NRCORSAFRA,   -1) <> NVL(:NEW.NRCORSAFRA,   -1)) THEN
         V_DESC := V_DESC || ' Safra:';
      END IF;
      IF (NVL(:NEW.NRCORINICSAF, -1) <> -1) OR (UPDATING AND (NVL(:NEW.NRCORINICSAF, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.NRCORINICSAF, -1) <> NVL(:NEW.NRCORINICSAF, -1)) THEN
               V_DESC := V_DESC || ' CorIniFimSaf=' || :OLD.NRCORINICSAF || '|' || :NEW.NRCORINICSAF;
            END IF;
         ELSE
            V_DESC := V_DESC || ' CorIniFimSaf=' || :NEW.NRCORINICSAF;
         END IF;
      END IF;
      IF (NVL(:NEW.NRCORENTRSAF, -1) <> -1) OR (UPDATING AND (NVL(:NEW.NRCORENTRSAF, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.NRCORENTRSAF, -1) <> NVL(:NEW.NRCORENTRSAF, -1)) THEN
               V_DESC := V_DESC || ' CorEntSaf=' || :OLD.NRCORENTRSAF || '|' || :NEW.NRCORENTRSAF;
            END IF;
         ELSE
            V_DESC := V_DESC || ' CorEntSaf=' || :NEW.NRCORENTRSAF;
         END IF;
      END IF;
      IF (NVL(:NEW.NRCORSAFRA, -1) <> -1) OR (UPDATING AND (NVL(:NEW.NRCORSAFRA, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.NRCORSAFRA, -1) <> NVL(:NEW.NRCORSAFRA, -1)) THEN
               V_DESC := V_DESC || ' CorSaf=' || :OLD.NRCORSAFRA || '|' || :NEW.NRCORSAFRA;
            END IF;
         ELSE
            V_DESC := V_DESC || ' CorSaf=' || :NEW.NRCORSAFRA;
         END IF;
      END IF; 
      IF (NVL(:OLD.IDPERCCOME, '') <> NVL(:NEW.IDPERCCOME, '')) THEN
         V_DESC := V_DESC || ' Montagem Card:';
      END IF;
      IF (NVL(:NEW.IDPERCCOME, '') <> '') OR (UPDATING AND (NVL(:NEW.IDPERCCOME, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.IDPERCCOME, '') <> NVL(:NEW.IDPERCCOME, '')) THEN
               IF :OLD.IDPERCCOME = 'P' THEN
                  V_DESC := V_DESC || ' MontCar=' || '%' || '|';
               ELSE
                  IF :OLD.IDPERCCOME = 'C' THEN
                     V_DESC := V_DESC || ' MontCar=' || 'Qtde' || '|';
                  ELSE
                     V_DESC := V_DESC || ' MontCar=|';
                  END IF;
               END IF;
               IF :NEW.IDPERCCOME = 'P' THEN
                  V_DESC := V_DESC || '%';
               ELSE
                  IF :NEW.IDPERCCOME = 'C' THEN
                     V_DESC := V_DESC || 'Qtde';
                  END IF;
               END IF;  
            END IF;
         ELSE
            IF :NEW.IDPERCCOME = 'P' THEN
               V_DESC := V_DESC || ' MontCar=' || '%';
            ELSE
               IF :NEW.IDPERCCOME = 'C' THEN
                  V_DESC := V_DESC || ' MontCar=' || 'Qtde';
               END IF; 
            END IF;
         END IF;
      END IF;
      IF (NVL(:OLD.NRCORNALTE, -1) <> NVL(:NEW.NRCORNALTE, -1)) OR
         (NVL(:OLD.NRCORNUTIL, -1) <> NVL(:NEW.NRCORNUTIL, -1)) THEN
         V_DESC := V_DESC || ' CorCar:'; 
      END IF; 
      IF (NVL(:NEW.NRCORNALTE, -1) <> -1) OR (UPDATING AND (NVL(:NEW.NRCORNALTE, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.NRCORNALTE, -1) <> NVL(:NEW.NRCORNALTE, -1)) THEN
               V_DESC := V_DESC || ' CorBloq=' || :OLD.NRCORNALTE || '|' || :NEW.NRCORNALTE;
            END IF;
         ELSE
            V_DESC := V_DESC || ' CorBloq=' || :NEW.NRCORNALTE;
         END IF;
      END IF; 
      IF (NVL(:NEW.NRCORNUTIL, -1) <> -1) OR (UPDATING AND (NVL(:NEW.NRCORNUTIL, -1) = -1)) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.NRCORNUTIL, -1) <> NVL(:NEW.NRCORNUTIL, -1)) THEN
               V_DESC := V_DESC || ' CorFer=' || :OLD.NRCORNUTIL || '|' || :NEW.NRCORNUTIL;
            END IF;
         ELSE
            V_DESC := V_DESC || ' CorFer=' || :NEW.NRCORNUTIL;
         END IF;
      END IF; 
      IF (NVL(:OLD.TXLAYOUTCATR, '') <> NVL(:NEW.TXLAYOUTCATR, '')) OR
         (NVL(:OLD.IDEFETCARDIA, '') <> NVL(:NEW.IDEFETCARDIA, '')) THEN
         V_DESC := V_DESC || ' ArqImp:';
      END IF;
      IF (NVL(:NEW.TXLAYOUTCATR, '') <> '') OR (UPDATING AND (NVL(:NEW.TXLAYOUTCATR, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.TXLAYOUTCATR, '') <> NVL(:NEW.TXLAYOUTCATR, '')) THEN
               V_DESC := V_DESC || ' LoutTxt=' || :OLD.TXLAYOUTCATR || '|' || :NEW.TXLAYOUTCATR;
            END IF;
         ELSE
            V_DESC := V_DESC || ' LoutTxt=' || :NEW.TXLAYOUTCATR;
         END IF;
      END IF; 
      IF (NVL(:NEW.IDEFETCARDIA, '') <> '') OR (UPDATING AND (NVL(:NEW.IDEFETCARDIA, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.IDEFETCARDIA, '') <> NVL(:NEW.IDEFETCARDIA, '')) THEN
               V_DESC := V_DESC || ' VerifEfeFecDia=' || :OLD.IDEFETCARDIA || '|' || :NEW.IDEFETCARDIA;
            END IF;
         ELSE
            V_DESC := V_DESC || ' VerifEfeFecDia=' || :NEW.IDEFETCARDIA;
         END IF;
      END IF; 
      IF (NVL(:OLD.IDAPRERECE,  '') <> NVL(:NEW.IDAPRERECE,  '')) OR
         (NVL(:OLD.IDGANHOCOCC, '') <> NVL(:NEW.IDGANHOCOCC, '')) OR
         (NVL(:OLD.IDAPROVCOCC, '') <> NVL(:NEW.IDAPROVCOCC, '')) OR
         (NVL(:OLD.IDPERDALIMP, '') <> NVL(:NEW.IDPERDALIMP, '')) OR
         (NVL(:OLD.IDAPROVLIMP, '') <> NVL(:NEW.IDAPROVLIMP, '')) OR
         (NVL(:OLD.IDTEMPPREP,  '') <> NVL(:NEW.IDTEMPPREP,  '')) THEN
         V_DESC := V_DESC || ' ConfPrat:';
      END IF;
      IF (NVL(:NEW.IDAPRERECE, '') <> '') OR (UPDATING AND (NVL(:NEW.IDAPRERECE, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.IDAPRERECE, '') <> NVL(:NEW.IDAPRERECE, '')) THEN
               V_DESC := V_DESC || ' AprProd=' || :OLD.IDAPRERECE || '|' || :NEW.IDAPRERECE;
            END IF;
         ELSE
            V_DESC := V_DESC || ' AprProd=' || :NEW.IDAPRERECE;
         END IF;
      END IF; 
      IF (NVL(:NEW.IDGANHOCOCC, '') <> '') OR (UPDATING AND (NVL(:NEW.IDGANHOCOCC, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.IDGANHOCOCC, '') <> NVL(:NEW.IDGANHOCOCC, '')) THEN
               V_DESC := V_DESC || ' GanhCoc=' || :OLD.IDGANHOCOCC || '|' || :NEW.IDGANHOCOCC;
            END IF;
         ELSE
            V_DESC := V_DESC || ' GanhCoc=' || :NEW.IDGANHOCOCC;
         END IF;
      END IF; 
      IF (NVL(:NEW.IDAPROVCOCC, '') <> '') OR (UPDATING AND (NVL(:NEW.IDAPROVCOCC, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.IDAPROVCOCC, '') <> NVL(:NEW.IDAPROVCOCC, '')) THEN
               V_DESC := V_DESC || ' AprCoc=' || :OLD.IDAPROVCOCC || '|' || :NEW.IDAPROVCOCC;
            END IF;
         ELSE
            V_DESC := V_DESC || ' AprCoc=' || :NEW.IDAPROVCOCC;
         END IF;
      END IF; 
      IF (NVL(:NEW.IDPERDALIMP, '') <> '') OR (UPDATING AND (NVL(:NEW.IDPERDALIMP, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.IDPERDALIMP, '') <> NVL(:NEW.IDPERDALIMP, '')) THEN
               V_DESC := V_DESC || ' PerLimp=' || :OLD.IDPERDALIMP || '|' || :NEW.IDPERDALIMP;
            END IF;
         ELSE
            V_DESC := V_DESC || ' PerLimp=' || :NEW.IDPERDALIMP;
         END IF;
      END IF; 
      IF (NVL(:NEW.IDAPROVLIMP, '') <> '') OR (UPDATING AND (NVL(:NEW.IDAPROVLIMP, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.IDAPROVLIMP, '') <> NVL(:NEW.IDAPROVLIMP, '')) THEN
               V_DESC := V_DESC || ' AprLimp=' || :OLD.IDAPROVLIMP || '|' || :NEW.IDAPROVLIMP;
            END IF;
         ELSE
            V_DESC := V_DESC || ' AprLimp=' || :NEW.IDAPROVLIMP;
         END IF;
      END IF; 
      IF (NVL(:NEW.IDTEMPPREP, '') <> '') OR (UPDATING AND (NVL(:NEW.IDTEMPPREP, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.IDTEMPPREP, '') <> NVL(:NEW.IDTEMPPREP, '')) THEN
               V_DESC := V_DESC || ' TempPrep=' || :OLD.IDTEMPPREP || '|' || :NEW.IDTEMPPREP;
            END IF;
         ELSE
            V_DESC := V_DESC || ' TempPrep=' || :NEW.IDTEMPPREP;
         END IF;
      END IF;
      IF (NVL(:OLD.IDQTLIQUBRUT, '') <> NVL(:NEW.IDQTLIQUBRUT, '')) THEN
         V_DESC := V_DESC || ' QtdeRec:';
      END IF; 
      IF (NVL(:NEW.IDQTLIQUBRUT, '') <> '') OR (UPDATING AND (NVL(:NEW.IDQTLIQUBRUT, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.IDQTLIQUBRUT, '') <> NVL(:NEW.IDQTLIQUBRUT, '')) THEN
               V_DESC := V_DESC || ' AtuaQtdRec=' || :OLD.IDQTLIQUBRUT || '|' || :NEW.IDQTLIQUBRUT;
            END IF;
         ELSE
            V_DESC := V_DESC || ' AtuaQtdRec=' || :NEW.IDQTLIQUBRUT;
         END IF;
      END IF; 
      IF (NVL(:OLD.CDTPRCONSFIX, '') <> NVL(:NEW.CDTPRCONSFIX, '')) OR
         (NVL(:OLD.CDFILCONSFIX, '') <> NVL(:NEW.CDFILCONSFIX, '')) OR
         (NVL(:OLD.CDPRACONSFIX, '') <> NVL(:NEW.CDPRACONSFIX, '')) THEN
         V_DESC := V_DESC || ' DefConFix:';
      END IF; 
      IF (NVL(:NEW.CDTPRCONSFIX, '') <> '') OR (UPDATING AND (NVL(:NEW.CDTPRCONSFIX, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.CDTPRCONSFIX, '') <> NVL(:NEW.CDTPRCONSFIX, '')) THEN
               V_DESC := V_DESC || ' TpConFix=' || :OLD.CDTPRCONSFIX || '|' || :NEW.CDTPRCONSFIX;
            END IF;
         ELSE
            V_DESC := V_DESC || ' TpConFix=' || :NEW.CDTPRCONSFIX;
         END IF;
      END IF; 
      IF ((NVL(:NEW.CDFILCONSFIX, '') <> '') OR (NVL(:NEW.CDPRACONSFIX, '') = '')) OR
         (UPDATING AND ((NVL(:NEW.CDPRACONSFIX, '') = '') OR (NVL(:NEW.CDFILCONSFIX, '') = ''))) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.CDFILCONSFIX, '') <> NVL(:NEW.CDFILCONSFIX, '')) THEN
               V_DESC := V_DESC || ' PratConFix=' || :OLD.CDFILCONSFIX || '|' || :NEW.CDFILCONSFIX;
            END IF;
            IF (NVL(:OLD.CDPRACONSFIX, '') <> NVL(:NEW.CDPRACONSFIX, '')) THEN
               IF (NVL(:OLD.CDFILCONSFIX, '') <> NVL(:NEW.CDFILCONSFIX, '')) THEN
                  V_DESC := V_DESC || ' - ' || :OLD.CDPRACONSFIX || '|' || :NEW.CDPRACONSFIX;
               ELSE
                  V_DESC := V_DESC || ' PratConFix=' || :OLD.CDPRACONSFIX || '|' || :NEW.CDPRACONSFIX;
               END IF;
            END IF;
         ELSE
            V_DESC := V_DESC || ' PratConFix=' || :NEW.CDFILCONSFIX || '|' || :NEW.CDPRACONSFIX;
         END IF;
      END IF; 
      IF (NVL(:OLD.CDTPRCONSPER, '') <> NVL(:NEW.CDTPRCONSPER, '')) OR
         (NVL(:OLD.CDFILCONSPER, '') <> NVL(:NEW.CDFILCONSPER, '')) OR
         (NVL(:OLD.CDPRACONSPER, '') <> NVL(:NEW.CDPRACONSPER, '')) THEN
         V_DESC := V_DESC || ' DefConPer:';
      END IF; 
      IF (NVL(:NEW.CDTPRCONSPER, '') <> '') OR (UPDATING AND (NVL(:NEW.CDTPRCONSPER, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.CDTPRCONSPER, '') <> NVL(:NEW.CDTPRCONSPER, '')) THEN
               V_DESC := V_DESC || ' TpConPer=' || :OLD.CDTPRCONSPER || '|' || :NEW.CDTPRCONSPER;
            END IF;
         ELSE
            V_DESC := V_DESC || ' TpConPer=' || :NEW.CDTPRCONSPER;
         END IF;
      END IF; 
      IF ((NVL(:NEW.CDFILCONSPER, '') <> '') OR (NVL(:NEW.CDPRACONSPER, '') <> '')) OR
         (UPDATING AND ((NVL(:NEW.CDPRACONSPER, '') = '') OR (NVL(:NEW.CDFILCONSPER, '') = ''))) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.CDFILCONSPER, '') <> NVL(:NEW.CDFILCONSPER, '')) THEN
               V_DESC := V_DESC || ' PratConPer=' || :OLD.CDFILCONSPER || '|' || :NEW.CDFILCONSPER;
            END IF;
            IF (NVL(:OLD.CDPRACONSPER, '') <> NVL(:NEW.CDPRACONSPER, '')) THEN
               IF (NVL(:OLD.CDFILCONSPER, '') <> NVL(:NEW.CDFILCONSPER, '')) THEN
                  V_DESC := V_DESC || ' - ' || :OLD.CDPRACONSPER || '|' || :NEW.CDPRACONSPER;
               ELSE
                  V_DESC := V_DESC || ' PratConPer=' || :OLD.CDPRACONSPER || '|' || :NEW.CDPRACONSPER;
               END IF;
            END IF;
         ELSE
            V_DESC := V_DESC || ' PratConPer=' || :NEW.CDFILCONSPER || '|' || :NEW.CDPRACONSPER;
         END IF;
      END IF;
      IF (NVL(:OLD.IDUTREQUPRAT, '') <> NVL(:NEW.IDUTREQUPRAT, '')) THEN
         V_DESC := V_DESC || ' ReqRetPrat:';
      END IF;
      IF (NVL(:NEW.IDUTREQUPRAT, '') <> '') OR (UPDATING AND (NVL(:NEW.IDUTREQUPRAT, '') = '')) THEN
         IF UPDATING THEN
            IF (NVL(:OLD.IDUTREQUPRAT, '') <> NVL(:NEW.IDUTREQUPRAT, '')) THEN
               V_DESC := V_DESC || ' RetPrat=' || :OLD.IDUTREQUPRAT || '|' || :NEW.IDUTREQUPRAT;
            END IF;
         ELSE
            V_DESC := V_DESC || ' RetPrat=' || :NEW.IDUTREQUPRAT;
         END IF;
      END IF; 
      V_DESC := V_DESC || ' Rdm='     || V_DSRDM;
      V_DESC := V_DESC || ' Mtodo='  || V_DSMETODO;
      V_DESC := V_DESC || ' Ip='      || V_DSIP;
      V_DESC := V_DESC || ' Usurio=' || V_DSUSUARIO;
      V_DESC := V_DESC || ' Operador='|| V_DSOPERADOR;
   END IF;
   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
            VALUES
               ('PARAMPLANEJA', V_DTOPER, V_USUARIO, V_TIPO, V_ITPESQ, SUBSTR(V_DESC, 1, 300),
                V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_DSOPERADOR, NVL(:NEW.CDFILIAL, :OLD.CDFILIAL));
         END IF;
      END IF;
   END IF;
END;
/