create or replace PROCEDURE FCT_GERA_CONTRATO (
  P_NRORG              IN NUMBER,
  P_NRSEQORCAMENTO     IN NUMBER,
  P_NRSEQCONTRATO      OUT NUMBER)
AS
  V_NRSEQMODCONTRATO   NUMBER;
  V_NRSEQCONTRATO      VARCHAR2(30);
  V_NRSEQFATUCONTR     VARCHAR2(30);
  V_NRSEQFATUITCONT    VARCHAR2(30);
  V_NRITSEQCONTRATO    VARCHAR2(30);
  V_NRITELESEQCONTRATO VARCHAR2(30);
  V_NRCONTRATOFCT      VARCHAR2(50);
  V_DTINICIOCONT       DATE;
  V_DTFINCONT          DATE;
  V_DTPADREAJCONT      DATE;
  V_NRITEMOCONTRATO    VARCHAR2(10);
  V_NRSEQREFEORCCONT   VARCHAR2(20);
  V_PRAZO              NUMBER;
  V_NRSEQREAJUSTE      NUMBER;
  V_NRSEQINDCONTR      NUMBER;
  V_NRSEQCONTDOC       NUMBER;
  V_SOMAVALOR          VARCHAR2(3);
  V_NRRELACESTRUTCONT  NUMBER;
  /* = PARAMETROS DE FORMACAO DE PREO DOS ITENS = */
  V_NRRELACFORMACAOCONT FCT_RELACFORMACAOCONT.NRRELACFORMACAOCONT%TYPE;
  V_NRFORMPRECOSERVICO  FCT_RELACFORMACAOPROP.NRFORMPRECOSERVICO%TYPE;
  /** PARAMETROS DO RATEIO, SERVICO, MEDIDA E COMPOSICAO **/
  V_NRTRABSERVCONT    FCT_TRABSERVCONTRATO.NRTRABSERVCONT%TYPE;
  V_NRMEDIDACONTRATO  FCT_RELACMEDIDACONTRATO.NRMEDIDACONTRATO%TYPE;
  V_NRCOMPSERVCONT    FCT_COMPSERVCONTRATO.NRCOMPSERVCONT%TYPE;
  /* == PARAMETROS DE NEGOCIACAO DE VALORES == */
  V_NRNEGOCIACAOCONTRATO    VARCHAR2(20);
  V_NRITEMOCONTRATO_NEGO    NUMBER;
  V_NRITEMCONTITPAI_NEGO    NUMBER;
  V_NRITNEGOCIACAOCONTRATO  VARCHAR2(20);
  V_NRPARCELANEGOCONT       VARCHAR2(20);
  V_NRDESCPERIODONEGOCONT   VARCHAR2(20);
  V_NRCOMPETENCIANEGOCONT   VARCHAR2(20);
  V_NRVARPRECBASESERVCONT   VARCHAR2(20);
BEGIN
    V_NRCONTRATOFCT := 1;
    FOR C_ORCAMENTO IN (
       SELECT NVL(O.NRTIPOORCAMENTO, ESC.NRTIPOORCAMENTO) AS NRTIPOORCAMENTO,
             O.NRSEQORCAMENTO,
             NVL(O.CDFILIAL, ESC.CDFILIAL) AS CDFILIAL,
             O.NRORCAMENTO,
             O.NRVERSAOORCAMENTO,
             ORCAMOD.NRSEQMODCONTRA AS NRSEQMODCONTRATO,
             O.NRPARCNEGOCIO,
             O.QTDIASCONTRATO,
             O.DTREFORCAMENTO,
             ORCAMOD.IDUTILIZAHIERSERV,
             O.CDOPERRESPONSAVEL,
             TP.IDUTILIZAVARPRECO,
             O.DSREFERENCIAORCA,
             O.DTACEITEORCA,
             O.VRORCAMENTO
        FROM FCT_ORCAMENTO O
        INNER JOIN FCT_RELACESCOPOPROPOSTA ESC
          ON O.NRSEQORCAMENTO = ESC.NRSEQORCAMENTO
         AND O.NRORG          = ESC.NRORG
        LEFT JOIN FCT_TIPOORCAMENTO TP
          ON NVL(O.NRTIPOORCAMENTO, ESC.NRTIPOORCAMENTO) = TP.NRTIPOORCAMENTO
         AND O.NRORG                                     = TP.NRORG
        LEFT JOIN FCT_ORCAMENTOMODELO ORCAMOD
          ON O.NRORCAMENTOMODELO = ORCAMOD.NRORCAMENTOMODELO
         AND O.NRORG             = ORCAMOD.NRORG
       WHERE O.NRORG             = P_NRORG
         AND O.NRSEQORCAMENTO    = P_NRSEQORCAMENTO)
    LOOP

        V_NRSEQMODCONTRATO := C_ORCAMENTO.NRSEQMODCONTRATO;
        IF V_NRSEQMODCONTRATO IS NULL THEN
          BEGIN
            SELECT NRSEQMODCONTRATO
              INTO V_NRSEQMODCONTRATO
              FROM FCT_PARAMETROGERAL;
          EXCEPTION
            WHEN NO_DATA_FOUND THEN
              V_NRSEQMODCONTRATO := NULL;
          END;
        END IF;

        FOR C_MODELOCONTRATO IN (
          SELECT MC.NRDIAVENPARCFAT, DECODE(MC.NRDIASVIGCONT, NULL, 0, MC.NRDIASVIGCONT) AS NRDIASVIGCONT,
                 MC.DTPADREAJCONT, MC.NRDIASPRORGCONT, MC.QTPOSTOTRABCONT, MC.VRPERCMULTQBCONT,
                 MC.CDTPINDFINCON, MC.IDPERVALFINCON, MC.CDINDFINCONT, MC.IDQTDIASCOMPCON,
                 MC.IDTPCOMPETCONT, MC.IDTPFATUINCOMP,MC.IDTPDTEMISSNF,MC.IDTPDTVENC,
                 MC.NRQTDIASCOMPCON, MC.NRDIACOMPETCONT, MC.NRDIADTEMISSNF, MC.IDSOMAFATUCONT,
                 MC.IDFATURACONTR, MC.CDMODPGTO, MC.QTPARCELASFATU, MC.NRDIAVENCPARCELASFATU, MC.DTINICFATCONTR,
                 NVL(MC.IDSITUACAOCONTRATO, 'P') AS IDSITUACAOCONTRATO, PARAM.NRGRUPOFATURA,
                 PARAM.IDSOMAFATUCONT AS IDSOMAFATUCONTFATU, PARAM.IDSOMAITGRUPFAT, PARAM.IDGERANFPARC,
                 PARAM.IDBLOQVRMEDIC, PARAM.IDGERARATEIO, PARAM.IDAPURAAPONTAMENTO
            FROM FCT_MODELOCONTRATO MC
            LEFT JOIN FCT_PARAMFATMODCONT PARAM
              ON MC.NRSEQMODCONTRA = PARAM.NRSEQMODCONTRA
             AND MC.NRORG = PARAM.NRORG
           WHERE MC.NRSEQMODCONTRA = V_NRSEQMODCONTRATO
             AND MC.NRORG          = P_NRORG
             AND ROWNUM            = 1
             AND MC.IDATIVO        = 'S')
        LOOP
            NOVO_CODIGO_NT('FCT_CONTRATO', V_NRSEQCONTRATO,1);
            V_DTINICIOCONT := C_ORCAMENTO.DTACEITEORCA;
            IF C_ORCAMENTO.QTDIASCONTRATO IS NOT NULL THEN
                V_DTFINCONT := V_DTINICIOCONT+TO_NUMBER(C_ORCAMENTO.QTDIASCONTRATO);
                V_PRAZO     := C_ORCAMENTO.QTDIASCONTRATO;
            ELSE
                V_DTFINCONT := V_DTINICIOCONT+TO_NUMBER(C_MODELOCONTRATO.NRDIASVIGCONT);
                V_PRAZO     := C_MODELOCONTRATO.NRDIASVIGCONT;
            END IF;

            IF C_MODELOCONTRATO.DTPADREAJCONT IS NOT NULL THEN
                V_DTPADREAJCONT := (TO_DATE('01/'||C_MODELOCONTRATO.DTPADREAJCONT||TO_CHAR(V_DTINICIOCONT,'/YYYY')))+365;
            END IF;

            INSERT INTO FCT_CONTRATO
                 (NRSEQCONTRATO,IDTPCONTRATO,CDFILIALORCA,NRVERSAOCONTRATO,NRCONTRATOFCT,NRSEQMODCONTRA,
                  NRPARCNEGOCIO,DSREFERENCIACONT,DTINICIOCONTRATO,DTFIMCONTRATO,NRDIASPRAZOCONT,
                  IDSITUACAOCONTRATO,NRDIAVENPARCFAT,CDTPINDFINCON,CDINDFINCONT,IDPERVALFINCON,
                  DTPADREAJCONT,NRDIASPRORGCONT,QTPOSTOTRABCONT,IDORIGCONTRATO,IDQTDIASCOMPCON,
                  IDTPCOMPETCONT,IDTPFATUINCOMP,IDTPDTEMISSNF,IDTPDTVENC,NRQTDIASCOMPCON,
                  NRDIACOMPETCONT,NRDIADTEMISSNF, IDSOMAFATUCONT, IDFATURACONTR, CDMODPGTO, DTINICFATCONTR,
                  NRORG, QTPARCELASFATU, NRDIAVENCPARCELASFATU, CDOPERRESPONSAVEL, NRTIPOORCAMENTO)
            VALUES
                 (V_NRSEQCONTRATO, 'S', C_ORCAMENTO.CDFILIAL, 1, V_NRSEQCONTRATO, V_NRSEQMODCONTRATO,
                 C_ORCAMENTO.NRPARCNEGOCIO, C_ORCAMENTO.DSREFERENCIAORCA, V_DTINICIOCONT, V_DTFINCONT, V_PRAZO,
                 C_MODELOCONTRATO.IDSITUACAOCONTRATO, NULL, C_MODELOCONTRATO.CDTPINDFINCON, C_MODELOCONTRATO.CDINDFINCONT,
                 C_MODELOCONTRATO.IDPERVALFINCON, V_DTPADREAJCONT, C_MODELOCONTRATO.NRDIASPRORGCONT, C_MODELOCONTRATO.QTPOSTOTRABCONT, 'G',
                 NULL, NULL, NULL,
                 NULL, NULL, NULL,
                 NULL, NULL, NULL,
                 NULL, NULL, C_MODELOCONTRATO.DTINICFATCONTR,
                 P_NRORG, NULL, NULL, C_ORCAMENTO.CDOPERRESPONSAVEL, C_ORCAMENTO.NRTIPOORCAMENTO);

            CRIA_MNEMONICO(P_NRORG,'C',V_NRSEQCONTRATO,V_NRCONTRATOFCT);
            UPDATE FCT_CONTRATO
                SET NRCONTRATOFCT = V_NRCONTRATOFCT
            WHERE NRORG         = P_NRORG
                AND NRSEQCONTRATO = V_NRSEQCONTRATO;

            FOR C_LOCAL IN (SELECT NRESTRUTURAM
                            FROM FCT_RELACESTRUTURAPROP
                            WHERE NRSEQORCAMENTO   = P_NRSEQORCAMENTO
                              AND NRORG            = P_NRORG
                              AND IDRELACESTRUTURA = 'PROPOSTA')
            LOOP
                NOVO_CODIGO_NT('NRRELACESTRUTCONT', V_NRRELACESTRUTCONT, 1);
                INSERT INTO FCT_RELACESTRUTURACONT (
                    NRRELACESTRUTCONT,  NRESTRUTURAM,      NRSEQCONTRATO,
                    NRITEMOCONTRATO,    IDRELACESTRUTURA,  VRITEMRATEIO,
                    NRORG,              VRPERCRATEIO,      DTINCLUSAO
                )
                VALUES (
                    V_NRRELACESTRUTCONT,  C_LOCAL.NRESTRUTURAM,  V_NRSEQCONTRATO,
                    NULL,                 'CONTRATO',            NULL,
                    P_NRORG,              NULL,                  SYSDATE
                );
            END LOOP;

            FOR C_ITEM IN (
              SELECT IT.CDPRECBASESERV, IT.CDSERVORCA, IT.CDPRODUTO, IT.SGUNIDADE,
                     IT.CDTPMEDIDASERV, IT.QTMEDIDAORCA, IT.IDFATURAORCA, IT.CDMODPGTO,
                     IT.NRGRUPOFATURA, IT.IDUNIDTEMPOLOCACAO, IT.QTITEMORCAMENTO,
                     IT.QTTEMPOLOCACAO,IT.NMITEMORCAMENTO, VRUNITITEMORCA, VRTOTALITEMORCA,
                     IT.DTINICFATORC, IT.IDMULTMEDVRTOT, IT.IDADICITEMORC, IT.IDADICCOBRITEMORC, IT.NRITEMORCAMENTO,
                     IT.QTPARCELASFATU, IT.NRDIAVENCPARCELASFATU, IT.NRTIPOORCAMENTO,
                     IT.VRPERCDESCORCA, IT.IDTPDESCORCA, IT.NMCONTRATUALITEMORCA, IT.VRUNITITEMORCATBLPRECO
                FROM FCT_ITEMORCAMENTO IT
               WHERE IT.NRORG          = P_NRORG
                 AND IT.NRSEQORCAMENTO = P_NRSEQORCAMENTO
                 AND IT.IDELEMENTO IS NULL
                 AND (IT.NRTIPOORCAMENTO = C_ORCAMENTO.NRTIPOORCAMENTO OR IT.NRTIPOORCAMENTO IS NULL)
            ) LOOP
                NOVO_CODIGO_NT('FCT_ITEMCONTRATO', V_NRITSEQCONTRATO, 1);
                INSERT INTO FCT_ITEMCONTRATO
                  (NRORG,NRITEMOCONTRATO, NRSEQCONTRATO,
                   CDPRODUTO,CDSERVORCA,SGUNIDADE,NMITEMCONTRATO,
                   QTITEMCONTRATO,CDTPMEDIDASERV,QTMEDIDACONTR, IDFATURACONTR,
                   CDMODPGTO,NRGRUPOFATURA,IDUNIDTEMPOSERV,QTTEMPOSERV,IDITEMATIVO,
                   VRUNITITEMCONT,VRTOTITEMCONT, DTINICFATCONTR, IDMULTMEDVRTOT,
                   IDADICITEMCONT, IDADICCOBRCONT,IDFATURAITEM,
                   QTPARCELASFATU, NRDIAVENCPARCELASFATU,
                   VRDESCONTO, IDTPDESCONTO, NRITEMORCAMENTO, NMCONTRATUALITEMCONT,
                   VRUNITITEMCONTTBLPRECO)
                VALUES
                    (P_NRORG, V_NRITSEQCONTRATO, V_NRSEQCONTRATO,
                     C_ITEM.CDPRODUTO, C_ITEM.CDSERVORCA, C_ITEM.SGUNIDADE, C_ITEM.NMITEMORCAMENTO,
                     C_ITEM.QTITEMORCAMENTO, C_ITEM.CDTPMEDIDASERV, C_ITEM.QTMEDIDAORCA, NULL,
                     NULL, NULL, C_ITEM.IDUNIDTEMPOLOCACAO, C_ITEM.QTTEMPOLOCACAO, 'S',
                     C_ITEM.VRUNITITEMORCA, C_ITEM.VRTOTALITEMORCA, C_ITEM.DTINICFATORC, C_ITEM.IDMULTMEDVRTOT,
                     C_ITEM.IDADICITEMORC, C_ITEM.IDADICCOBRITEMORC, NVL(V_SOMAVALOR,'SIM'),
                     C_ITEM.QTPARCELASFATU, C_ITEM.NRDIAVENCPARCELASFATU,
                     C_ITEM.VRPERCDESCORCA, DECODE(C_ITEM.IDTPDESCORCA, 'N', 'S', C_ITEM.IDTPDESCORCA), C_ITEM.NRITEMORCAMENTO,
                     C_ITEM.NMCONTRATUALITEMORCA, C_ITEM.VRUNITITEMORCATBLPRECO);

                FOR C_ITELEMENTO IN (
                    SELECT IT.CDPRECBASESERV, IT.CDSERVORCA, IT.CDPRODUTO, IT.SGUNIDADE,
                         IT.CDTPMEDIDASERV, IT.QTMEDIDAORCA, IT.IDFATURAORCA, IT.CDMODPGTO,
                         IT.NRGRUPOFATURA, IT.IDUNIDTEMPOLOCACAO, IT.QTITEMORCAMENTO,
                         IT.QTTEMPOLOCACAO,IT.NMITEMORCAMENTO, VRUNITITEMORCA, VRTOTALITEMORCA,
                         IT.DTINICFATORC, IT.IDMULTMEDVRTOT, IT.IDADICITEMORC, IT.IDADICCOBRITEMORC, IT.NRITEMORCAMENTO,
                         IT.QTPARCELASFATU, IT.NRDIAVENCPARCELASFATU, IT.NRTIPOORCAMENTO,
                         IT.VRPERCDESCORCA, IT.IDTPDESCORCA, IT.NMCONTRATUALITEMORCA, IT.IDELEMENTO,
                         IT.VRUNITITEMORCATBLPRECO, IT.CDTPMEDIDAVARIAVEL
                    FROM FCT_ITEMORCAMENTO IT
                   WHERE IT.NRORG              = P_NRORG
                     AND IT.NRSEQORCAMENTO     = P_NRSEQORCAMENTO
                     AND IT.CDSERVORCA         = C_ITEM.CDSERVORCA
                     AND IT.NRITEMORCAMENTOPAI = C_ITEM.NRITEMORCAMENTO
                     AND IT.IDELEMENTO IS NOT NULL
                ) LOOP
                    NOVO_CODIGO_NT('FCT_ITEMCONTRATO', V_NRITELESEQCONTRATO, 1);
                    INSERT INTO FCT_ITEMCONTRATO
                      (NRORG, NRITEMOCONTRATO, NRSEQCONTRATO,
                       CDPRODUTO,CDSERVORCA,SGUNIDADE,NMITEMCONTRATO,
                       QTITEMCONTRATO,CDTPMEDIDASERV,QTMEDIDACONTR, IDFATURACONTR,
                       CDMODPGTO,NRGRUPOFATURA,IDUNIDTEMPOSERV,QTTEMPOSERV,IDITEMATIVO,
                       VRUNITITEMCONT,VRTOTITEMCONT, DTINICFATCONTR, IDMULTMEDVRTOT,
                       IDADICITEMCONT, IDADICCOBRCONT,IDFATURAITEM,
                       QTPARCELASFATU, NRDIAVENCPARCELASFATU,
                       VRDESCONTO, IDTPDESCONTO, NRITEMORCAMENTO, NMCONTRATUALITEMCONT, IDELEMENTO,
                       NRITEMCONTRATOPAI, VRUNITITEMCONTTBLPRECO, CDTPMEDIDAVARIAVEL)
                    VALUES
                        (P_NRORG, V_NRITELESEQCONTRATO, V_NRSEQCONTRATO,
                         C_ITELEMENTO.CDPRODUTO, C_ITELEMENTO.CDSERVORCA, C_ITELEMENTO.SGUNIDADE, C_ITELEMENTO.NMITEMORCAMENTO,
                         C_ITELEMENTO.QTITEMORCAMENTO, C_ITELEMENTO.CDTPMEDIDASERV, C_ITELEMENTO.QTMEDIDAORCA, NULL,
                         NULL, NULL, C_ITELEMENTO.IDUNIDTEMPOLOCACAO, C_ITELEMENTO.QTTEMPOLOCACAO, 'S',
                         C_ITELEMENTO.VRUNITITEMORCA, C_ITELEMENTO.VRTOTALITEMORCA, C_ITELEMENTO.DTINICFATORC, C_ITELEMENTO.IDMULTMEDVRTOT,
                         C_ITELEMENTO.IDADICITEMORC, C_ITELEMENTO.IDADICCOBRITEMORC, NVL(V_SOMAVALOR,'SIM'),
                         C_ITELEMENTO.QTPARCELASFATU, C_ITELEMENTO.NRDIAVENCPARCELASFATU,
                         C_ITELEMENTO.VRPERCDESCORCA, DECODE(C_ITELEMENTO.IDTPDESCORCA, 'N', 'S', C_ITELEMENTO.IDTPDESCORCA), C_ITELEMENTO.NRITEMORCAMENTO,
                         C_ITELEMENTO.NMCONTRATUALITEMORCA, C_ITELEMENTO.IDELEMENTO,
                         V_NRITSEQCONTRATO, C_ITELEMENTO.VRUNITITEMORCATBLPRECO, C_ITELEMENTO.CDTPMEDIDAVARIAVEL);
                END LOOP; --C_ITELEMENTO

                BEGIN
                    SELECT NRFORMPRECOSERVICO
                    INTO V_NRFORMPRECOSERVICO
                    FROM FCT_RELACFORMACAOPROP FORMPROP
                    WHERE FORMPROP.NRORG          = P_NRORG
                     AND FORMPROP.NRSEQORCAMENTO  = P_NRSEQORCAMENTO
                     AND FORMPROP.NRITEMORCAMENTO = C_ITEM.NRITEMORCAMENTO;
                EXCEPTION
                    WHEN NO_DATA_FOUND THEN
                        BEGIN
                            V_NRFORMPRECOSERVICO := NULL;
                        END;
                END;

                IF V_NRFORMPRECOSERVICO IS NOT NULL THEN
                    NOVO_CODIGO_NT('FCT_RELACFORMACAOCONT', V_NRRELACFORMACAOCONT, 1, P_NRORG);
                    INSERT INTO FCT_RELACFORMACAOCONT
                        (NRRELACFORMACAOCONT, NRFORMPRECOSERVICO, NRSEQCONTRATO,
                            NRITEMOCONTRATO, NRORG, IDATIVO, DTINCLUSAO, DTULTATU,
                            NRORGINCLUSAO, NRORGULTATU, CDOPERULTATU,
                            NRREAJUSCONTFORMPREC)
                    VALUES (V_NRRELACFORMACAOCONT, V_NRFORMPRECOSERVICO, V_NRSEQCONTRATO,
                            V_NRITSEQCONTRATO, P_NRORG, 'S', SYSDATE, NULL,
                            P_NRORG, NULL, NULL, NULL);
                END IF;

                FOR C_RATEIO IN (SELECT NRESTRUTURAM, VRITEMRATEIO, VRPERCRATEIO
                                   FROM FCT_RELACESTRUTURAPROP
                                  WHERE NRSEQORCAMENTO   = P_NRSEQORCAMENTO
                                    AND NRORG            = P_NRORG
                                    AND NRITEMORCAMENTO  = C_ITEM.NRITEMORCAMENTO
                                    AND IDRELACESTRUTURA = 'RATEIO')
                LOOP
                    NOVO_CODIGO_NT('NRRELACESTRUTCONT', V_NRRELACESTRUTCONT, 1);
                    INSERT INTO FCT_RELACESTRUTURACONT (
                        NRRELACESTRUTCONT,  NRESTRUTURAM,      NRSEQCONTRATO,
                        NRITEMOCONTRATO,    IDRELACESTRUTURA,  VRITEMRATEIO,
                        NRORG,              VRPERCRATEIO,      DTINCLUSAO
                    )
                    VALUES (
                        V_NRRELACESTRUTCONT,  C_RATEIO.NRESTRUTURAM,  V_NRSEQCONTRATO,
                        V_NRITSEQCONTRATO,    'RATEIO',               C_RATEIO.VRITEMRATEIO,
                        P_NRORG,              C_RATEIO.VRPERCRATEIO,  SYSDATE
                    );

                    NOVO_CODIGO_NT('NRRELACESTRUTCONT', V_NRRELACESTRUTCONT, 1);
                    INSERT INTO FCT_RELACESTRUTURACONT (
                        NRRELACESTRUTCONT,  NRESTRUTURAM,      NRSEQCONTRATO,
                        NRITEMOCONTRATO,    IDRELACESTRUTURA,  VRITEMRATEIO,
                        NRORG,              VRPERCRATEIO,      DTINCLUSAO
                    )
                    VALUES (
                        V_NRRELACESTRUTCONT,  C_RATEIO.NRESTRUTURAM,  V_NRSEQCONTRATO,
                        NULL,                 'CONTRATO',             NULL,
                        P_NRORG,              NULL,                   SYSDATE
                    );
                END LOOP; --C_RATEIO
            END LOOP; --C_ITEM

            FOR C_REAJUSTE IN (SELECT NRSEQMODREAJUS, NMMODREAJUSCONTR, IDTPREAJUSTE,
                                   IDTPMESREAJUSTE, NRQTDREAJUSTE, NRORG, IDATIVO
                               FROM FCT_MODREAJUSTCONTR
                               WHERE NRSEQMODCONTRA = V_NRSEQMODCONTRATO
            ) LOOP
                NOVO_CODIGO_NT('NRSEQREAJUS', V_NRSEQREAJUSTE,1);
                INSERT INTO FCT_REAJUSTCONTR
                      (NRSEQCONTRATO,NRSEQREAJUS, NMREAJUSCONTR,
                       IDTPREAJUSTE, IDTPMESREAJUSTE,NRQTDREAJUSTE,
                       IDATIVO, DTINCLUSAO)
                    VALUES
                      (V_NRSEQCONTRATO,V_NRSEQREAJUSTE, C_REAJUSTE.NMMODREAJUSCONTR,
                       C_REAJUSTE.IDTPREAJUSTE, C_REAJUSTE.IDTPMESREAJUSTE, C_REAJUSTE.NRQTDREAJUSTE,
                       'S',SYSDATE);

                FOR C_INDICE IN(SELECT CDTPINDICE, IDPERVALOR, CDINDICE, VRPERCINDCONTR, NRORG
                           FROM FCT_MODINDCONTR
                          WHERE NRSEQMODREAJUS = C_REAJUSTE.NRSEQMODREAJUS )LOOP
                    NOVO_CODIGO_NT('NRSEQINDCONTR', V_NRSEQINDCONTR,1);
                    INSERT INTO FCT_INDICECONTR
                      (NRSEQINDCONTR,NRSEQREAJUS, NRSEQCONTRATO,
                       CDTPINDICE, IDPERVALOR, CDINDICE, VRPERCINDCONTR,
                       IDATIVO, DTINCLUSAO)
                    VALUES
                      (V_NRSEQINDCONTR,V_NRSEQREAJUSTE, V_NRSEQCONTRATO,
                       C_INDICE.CDTPINDICE, C_INDICE.IDPERVALOR, C_INDICE.CDINDICE,
                       C_INDICE.VRPERCINDCONTR, 'S',SYSDATE);
             END LOOP;
            END LOOP;

            FOR C_CONTRATODOC IN (
                SELECT FCT_MODELODOC.NRSEQMODDOCFCT,
                       FCT_MODELODOC.NRMODELODOCFCT,
                       FCT_MODELODOC.IDIDIOMA,
                       FCT_MODELODOC.TXMODELODOCORCA,
                       FCT_MODELODOC.NRORG,
                       FCT_MODELODOC.NMARQUIVO,
                       FCT_MODELODOC.DSCAMINHOARQ,
                       FCT_MODELODOC.DSTIPO,
                       FCT_MODELODOC.VRTAMANHO,
                       MODCONT.IDSITUACAOCONTRATO
                   FROM FCT_MODELODOC
                   INNER JOIN (SELECT DISTINCT NRSEQMODDOCFCT, IDSITUACAOCONTRATO, NRORG
                                 FROM FCT_MODELODOCCONTR
                                WHERE NRORG = P_NRORG
                                  AND NRSEQMODCONTRA IN (SELECT TP.NRSEQMODCONTRATO
                                                           FROM FCT_TIPOORCAMENTO TP
                                                           INNER JOIN FCT_RELACESCOPOPROPOSTA REL
                                                           ON TP.NRTIPOORCAMENTO = REL.NRTIPOORCAMENTO
                                                           AND TP.NRORG           = REL.NRORG
                                                         WHERE REL.NRSEQORCAMENTO = C_ORCAMENTO.NRSEQORCAMENTO
                                                           AND REL.NRORG          = P_NRORG)
                                  AND (IDSITUACAOCONTRATO = 'P'
                                        OR (IDSITUACAOCONTRATO IS NULL AND (SELECT COUNT(DOC.NRSEQMODDOCFCT)
                                            FROM FCT_MODELODOCCONTR DOC
                                            WHERE DOC.IDSITUACAOCONTRATO = 'P'
                                              AND DOC.NRSEQMODDOCFCT = FCT_MODELODOCCONTR.NRSEQMODDOCFCT) = 0))) MODCONT
                 ON FCT_MODELODOC.NRORG = MODCONT.NRORG
                 AND FCT_MODELODOC.NRSEQMODDOCFCT = MODCONT.NRSEQMODDOCFCT
                 WHERE FCT_MODELODOC.NRORG = P_NRORG
            ) LOOP
                NOVO_CODIGO_NT('NRSEQCONTDOC', V_NRSEQCONTDOC,1);
                INSERT INTO FCT_CONTRATODOC (
                   NRSEQCONTDOC,   NRSEQCONTRATO,    NRSEQMODDOCFCT,
                   IDIDIOMA,       TXMODELODOCORCA,  NRORG,
                   IDATIVO,        DTINCLUSAO,       NMARQUIVO,
                   DSCAMINHOARQ,   DSTIPO,           VRTAMANHO,
                   IDSITUACAOCONTRATO
                )
                VALUES (
                   V_NRSEQCONTDOC,             V_NRSEQCONTRATO,                C_CONTRATODOC.NRSEQMODDOCFCT,
                   C_CONTRATODOC.IDIDIOMA,     C_CONTRATODOC.TXMODELODOCORCA,  P_NRORG,
                   'S',                        SYSDATE,                        C_CONTRATODOC.NMARQUIVO,
                   C_CONTRATODOC.DSCAMINHOARQ, C_CONTRATODOC.DSTIPO,           C_CONTRATODOC.VRTAMANHO,
                   C_CONTRATODOC.IDSITUACAOCONTRATO
                );
            END LOOP;

            FOR C_NEGOCIACAO IN (
             SELECT NRNEGOCIACAOPROPOSTA,
                    NRTIPOORCAMENTO,
                    IDTPFATURA,
                    CDFILIALFATURA,
                    NRPARCFATURA,
                    CDTIPOOPERFATURA,
                    CDSERIENF,
                    CDEMPRESA,
                    CDINSCESTA,
                    CDINSCMUNI,
                    VRTOTITEM,
                    VRPERCDESCITEM,
                    VRDESCITEM,
                    VRTOTITEMCOMDESC,
                    IDATIVO
               FROM FCT_NEGOCIACAOPROPOSTA
              WHERE NRSEQORCAMENTO  = P_NRSEQORCAMENTO
                AND NRORG           = P_NRORG
                AND NRTIPOORCAMENTO = C_ORCAMENTO.NRTIPOORCAMENTO
            ) LOOP
                NOVO_CODIGO_NT('FCT_NEGOCIACAOCONTRATO', V_NRNEGOCIACAOCONTRATO, 1, P_NRORG);
                INSERT INTO FCT_NEGOCIACAOCONTRATO (
                    NRNEGOCIACAOCONTRATO,   NRSEQCONTRATO,        NRTIPOORCAMENTO,
                    IDTPFATURA,             CDFILIALFATURA,       NRPARCFATURA,
                    CDTIPOOPERFATURA,       CDSERIENF,            CDEMPRESA,
                    CDINSCESTA,             CDINSCMUNI,           VRTOTITEM,
                    VRPERCDESCITEM,         VRDESCITEM,           VRTOTITEMCOMDESC,
                    IDATIVO,                NRORG,                DTINCLUSAO,
                    NRORGINCLUSAO,          NRNEGOCIACAOPROPOSTA
                )
                VALUES (
                    V_NRNEGOCIACAOCONTRATO,        V_NRSEQCONTRATO,                   C_NEGOCIACAO.NRTIPOORCAMENTO,
                    C_NEGOCIACAO.IDTPFATURA,       C_NEGOCIACAO.CDFILIALFATURA,       C_NEGOCIACAO.NRPARCFATURA,
                    C_NEGOCIACAO.CDTIPOOPERFATURA, C_NEGOCIACAO.CDSERIENF,            C_NEGOCIACAO.CDEMPRESA,
                    C_NEGOCIACAO.CDINSCESTA,       C_NEGOCIACAO.CDINSCMUNI,           C_NEGOCIACAO.VRTOTITEM,
                    C_NEGOCIACAO.VRPERCDESCITEM,   C_NEGOCIACAO.VRDESCITEM,           C_NEGOCIACAO.VRTOTITEMCOMDESC,
                    C_NEGOCIACAO.IDATIVO,          P_NRORG,                           SYSDATE,
                    P_NRORG,                       C_NEGOCIACAO.NRNEGOCIACAOPROPOSTA
                );

                FOR C_ITNEGOCIACAO IN (
                    SELECT NRITNEGOCIACAOPROPOSTA,
                            NRITEMORCAMENTO,
                            NRITEMORCAMENTOPAI,
                            VRTOTITEM,
                            VRPERCDESCITEM,
                            VRDESCITEM,
                            VRTOTITEMCOMDESC,
                            CDSERVORCA,
                            CDPRODFATURA,
                            NRPARCFATURA,
                            IDATIVO
                       FROM FCT_ITNEGOCIACAOPROPOSTA
                      WHERE NRNEGOCIACAOPROPOSTA = C_NEGOCIACAO.NRNEGOCIACAOPROPOSTA
                        AND NRORG                = P_NRORG
                ) LOOP
                    BEGIN
                        SELECT NRITEMOCONTRATO, NRITEMCONTRATOPAI
                          INTO V_NRITEMOCONTRATO_NEGO, V_NRITEMCONTITPAI_NEGO
                          FROM FCT_ITEMCONTRATO
                         WHERE NRSEQCONTRATO   = V_NRSEQCONTRATO
                           AND NRITEMORCAMENTO = C_ITNEGOCIACAO.NRITEMORCAMENTO
                           AND NRORG           = P_NRORG;
                    EXCEPTION WHEN NO_DATA_FOUND THEN
                        V_NRITEMOCONTRATO_NEGO := NULL;
                    END;
                    NOVO_CODIGO_NT('FCT_ITNEGOCIACAOCONTRATO', V_NRITNEGOCIACAOCONTRATO, 1, P_NRORG);
                    INSERT INTO FCT_ITNEGOCIACAOCONTRATO (
                         NRITNEGOCIACAOCONTRATO, NRNEGOCIACAOCONTRATO,   NRITEMOCONTRATO,
                         NRITEMORCAMENTO,        NRITEMORCAMENTOPAI,     VRTOTITEM,
                         VRPERCDESCITEM,         VRDESCITEM,             VRTOTITEMCOMDESC,
                         CDSERVORCA,             CDPRODFATURA,           NRPARCFATURA,
                         IDATIVO,                NRORG,                  DTINCLUSAO,
                         NRORGINCLUSAO,          NRITNEGOCIACAOPROPOSTA, NRITEMCONTRATOPAI
                    ) VALUES (
                         V_NRITNEGOCIACAOCONTRATO,      V_NRNEGOCIACAOCONTRATO,                V_NRITEMOCONTRATO_NEGO,
                         NULL,                          NULL,                                  C_ITNEGOCIACAO.VRTOTITEM,
                         C_ITNEGOCIACAO.VRPERCDESCITEM, C_ITNEGOCIACAO.VRDESCITEM,             C_ITNEGOCIACAO.VRTOTITEMCOMDESC,
                         C_ITNEGOCIACAO.CDSERVORCA,     C_ITNEGOCIACAO.CDPRODFATURA,           C_ITNEGOCIACAO.NRPARCFATURA,
                         C_ITNEGOCIACAO.IDATIVO,        P_NRORG,                               SYSDATE,
                         P_NRORG,                       C_ITNEGOCIACAO.NRITNEGOCIACAOPROPOSTA, V_NRITEMCONTITPAI_NEGO
                    );
                END LOOP; --C_ITNEGOCIACAO

                FOR C_PARCELA_NEGO IN (
                    SELECT NRPARCELANEGOPROP,
                           QTDIASFATURAMENTO,
                           NRDIAVENCIMENTO,
                           VRPARCELA,
                           IDATIVO
                      FROM FCT_PARCELANEGOPROP
                     WHERE NRNEGOCIACAOPROPOSTA = C_NEGOCIACAO.NRNEGOCIACAOPROPOSTA
                       AND NRORG                = P_NRORG
                ) LOOP
                     NOVO_CODIGO_NT('FCT_PARCELANEGOCONT', V_NRPARCELANEGOCONT, 1, P_NRORG);
                     INSERT INTO FCT_PARCELANEGOCONT (
                         NRPARCELANEGOCONT, NRNEGOCIACAOCONTRATO, QTDIASFATURAMENTO,
                         NRDIAVENCIMENTO,   VRPARCELA,            IDATIVO,
                         NRORG,             DTINCLUSAO,           NRORGINCLUSAO,
                         NRPARCELANEGOPROP
                     )
                     VALUES (
                         V_NRPARCELANEGOCONT,              V_NRNEGOCIACAOCONTRATO,   C_PARCELA_NEGO.QTDIASFATURAMENTO,
                         C_PARCELA_NEGO.NRDIAVENCIMENTO,   C_PARCELA_NEGO.VRPARCELA, C_PARCELA_NEGO.IDATIVO,
                         P_NRORG,                          SYSDATE,                  P_NRORG,
                         C_PARCELA_NEGO.NRPARCELANEGOPROP
                     );
                END LOOP; --C_PARCELA_NEGO

                FOR C_DESCPERIODO_NEGO IN (
                     SELECT NRDESCPERIODONEGOPROP,
                            VRPERCDESCITEM,
                            VRDESCITEM,
                            VRTOTITEMCOMDESC,
                            QTMESESDESC,
                            DTFINALVALIDADEDESC,
                            IDATIVO,
                            NRORDEMAPLICADESC
                       FROM FCT_DESCPERIODONEGOPROP
                      WHERE NRNEGOCIACAOPROPOSTA = C_NEGOCIACAO.NRNEGOCIACAOPROPOSTA
                        AND NRORG                = P_NRORG
                ) LOOP
                     NOVO_CODIGO_NT('FCT_DESCPERIODONEGOCONT', V_NRDESCPERIODONEGOCONT, 1, P_NRORG);
                     INSERT INTO FCT_DESCPERIODONEGOCONT (
                         NRDESCPERIODONEGOCONT, NRNEGOCIACAOCONTRATO, VRPERCDESCITEM,
                         VRDESCITEM,            VRTOTITEMCOMDESC,     QTMESESDESC,
                         DTFINALVALIDADEDESC,   IDATIVO,              NRORG,
                         DTINCLUSAO,            NRORGINCLUSAO,        NRDESCPERIODONEGOPROP,
                         NRORDEMAPLICADESC
                     )
                     VALUES (
                         V_NRDESCPERIODONEGOCONT,                V_NRNEGOCIACAOCONTRATO,              C_DESCPERIODO_NEGO.VRPERCDESCITEM,
                         C_DESCPERIODO_NEGO.VRDESCITEM,          C_DESCPERIODO_NEGO.VRTOTITEMCOMDESC, C_DESCPERIODO_NEGO.QTMESESDESC,
                         C_DESCPERIODO_NEGO.DTFINALVALIDADEDESC, C_DESCPERIODO_NEGO.IDATIVO,          P_NRORG,
                         SYSDATE,                                P_NRORG,                             C_DESCPERIODO_NEGO.NRDESCPERIODONEGOPROP,
                         C_DESCPERIODO_NEGO.NRORDEMAPLICADESC
                     );
                END LOOP; --C_DESCPERIODO_NEGO

                FOR C_COMPET IN (
                     SELECT NRDIACOMPETINI,
                            NRDIACOMPETFIN,
                            IDMESCOMPETINI,
                            IDMESCOMPETFIN,
                            QTDIASAPURACAO,
                            IDTPCALCVENC,
                            NRDIACALCVENC,
                            IDMESCALCVENC,
                            QTDIASFATUVENC,
                            IDATIVO
                       FROM FCT_COMPETENCIANEGOPROP
                      WHERE NRNEGOCIACAOPROPOSTA = C_NEGOCIACAO.NRNEGOCIACAOPROPOSTA
                        AND NRORG                = P_NRORG
                ) LOOP
                     NOVO_CODIGO_NT('FCT_COMPETENCIANEGOCONT', V_NRCOMPETENCIANEGOCONT, 1, P_NRORG);
                     INSERT INTO FCT_COMPETENCIANEGOCONT (
                         NRCOMPETENCIANEGOCONT, NRNEGOCIACAOCONTRATO, NRDIACOMPETINI,
                         NRDIACOMPETFIN,        IDMESCOMPETINI,       IDMESCOMPETFIN,
                         QTDIASAPURACAO,        IDTPCALCVENC,         NRDIACALCVENC,
                         IDMESCALCVENC,         QTDIASFATUVENC,       IDATIVO,
                         NRORG,                 DTINCLUSAO,           NRORGINCLUSAO
                     )
                     VALUES (
                         V_NRCOMPETENCIANEGOCONT, V_NRNEGOCIACAOCONTRATO,  C_COMPET.NRDIACOMPETINI,
                         C_COMPET.NRDIACOMPETFIN, C_COMPET.IDMESCOMPETINI, C_COMPET.IDMESCOMPETFIN,
                         C_COMPET.QTDIASAPURACAO, C_COMPET.IDTPCALCVENC,   C_COMPET.NRDIACALCVENC,
                         C_COMPET.IDMESCALCVENC,  C_COMPET.QTDIASFATUVENC, C_COMPET.IDATIVO,
                         P_NRORG,                 SYSDATE,                 P_NRORG
                     );
                END LOOP; --C_COMPET
            END LOOP; --C_NEGOCIACAO
        END LOOP;

        FOR C_ELEMENTOS IN (
            SELECT NRCOMPSERVICO,
              NRITCOMPSERVICO,
              IDESCOLHIDO,
              CDSERVORCA,
              QTSERVORCA,
              CDTPMEDIDASERV,
              QTMEDSERVORCA,
              VRUNITSERVORCA,
              VRTOTSERVORCA,
              IDELEMENTO,
              IDELEMENTOPAI,
              IDTIPOELEMENTO,
              IDSERVOBRIGCOMP,
              QTMEDIDAVARIAVEL,
              QTMEDIDACALC
          FROM FCT_TRABSERVORCAMENTO
          WHERE NRSEQORCAMENTO  = P_NRSEQORCAMENTO
            AND NRORG           = P_NRORG
        ) LOOP
            NOVO_CODIGO_NT('FCT_TRABSERVCONTRATO', V_NRTRABSERVCONT, 1, P_NRORG);
            INSERT INTO FCT_TRABSERVCONTRATO (
                NRTRABSERVCONT,  NRSEQCONTRATO,    NRTIPOORCAMENTO,
                NRCOMPSERVICO,   NRITCOMPSERVICO,  IDESCOLHIDO,
                CDSERVORCA,      QTSERVORCA,       CDTPMEDIDASERV,
                QTMEDSERVORCA,   VRUNITSERVORCA,   VRTOTSERVORCA,
                IDELEMENTO,      IDELEMENTOPAI,    IDTIPOELEMENTO,
                IDSERVOBRIGCOMP, QTMEDIDAVARIAVEL, QTMEDIDACALC,
                NRORG,           IDATIVO,          DTINCLUSAO,
                DTULTATU,        NRORGINCLUSAO,    CDOPERINCLUSAO,
                NRORGULTATU,     CDOPERULTATU
            ) VALUES (
                V_NRTRABSERVCONT,            V_NRSEQCONTRATO,              C_ORCAMENTO.NRTIPOORCAMENTO,
                C_ELEMENTOS.NRCOMPSERVICO,   C_ELEMENTOS.NRITCOMPSERVICO,  C_ELEMENTOS.IDESCOLHIDO,
                C_ELEMENTOS.CDSERVORCA,      C_ELEMENTOS.QTSERVORCA,       C_ELEMENTOS.CDTPMEDIDASERV,
                C_ELEMENTOS.QTMEDSERVORCA,   C_ELEMENTOS.VRUNITSERVORCA,   C_ELEMENTOS.VRTOTSERVORCA,
                C_ELEMENTOS.IDELEMENTO,      C_ELEMENTOS.IDELEMENTOPAI,    C_ELEMENTOS.IDTIPOELEMENTO,
                C_ELEMENTOS.IDSERVOBRIGCOMP, C_ELEMENTOS.QTMEDIDAVARIAVEL, C_ELEMENTOS.QTMEDIDACALC,
                P_NRORG,                     'S',                          SYSDATE,
                NULL,                        P_NRORG,                      C_ORCAMENTO.CDOPERRESPONSAVEL,
                NULL,                        NULL
            );
        END LOOP; -- C_ELEMENTOS

        IF(C_ORCAMENTO.IDUTILIZAVARPRECO = 'S') THEN
            FOR C_TPMEDIDA IN(
                SELECT NRSEQORCAMENTO,
                CDTPMEDIDAVARIAVEL,
                QTMEDIDAVARIAVEL,
                IDELEMENTORAIZ,
                QTFRANQUIA
            FROM FCT_RELACMEDIDAPROPOSTA
            WHERE NRSEQORCAMENTO    = P_NRSEQORCAMENTO
                AND NRORG           = P_NRORG
            ) LOOP
                NOVO_CODIGO_NT('FCT_RELACMEDIDACONTRATO', V_NRMEDIDACONTRATO, 1, P_NRORG);
                INSERT INTO FCT_RELACMEDIDACONTRATO (
                    NRMEDIDACONTRATO,
                    NRSEQCONTRATO,
                    CDTPMEDIDAVARIAVEL,
                    QTMEDIDAVARIAVEL,
                    IDELEMENTORAIZ,
                    QTFRANQUIA,
                    NRORG,
                    DTINCLUSAO,
                    DTULTATU,
                    NRORGINCLUSAO,
                    CDOPERINCLUSAO,
                    NRORGULTATU,
                    CDOPERULTATU,
                    IDATIVO
                ) VALUES (
                    V_NRMEDIDACONTRATO,
                    V_NRSEQCONTRATO,
                    C_TPMEDIDA.CDTPMEDIDAVARIAVEL,
                    C_TPMEDIDA.QTMEDIDAVARIAVEL,
                    C_TPMEDIDA.IDELEMENTORAIZ,
                    C_TPMEDIDA.QTFRANQUIA,
                    P_NRORG,
                    SYSDATE,
                    NULL,
                    P_NRORG,
                    C_ORCAMENTO.CDOPERRESPONSAVEL,
                    NULL,
                    NULL,
                    'S'
                );

            END LOOP; -- C_TPMEDIDA

            FOR C_TABPRECO IN (SELECT NRVARPRECBASESERVORCA, NRSEQORCAMENTO, CDSERVORCA, CDTPMEDIDASERV, CDTPMEDIDAVARIAVEL, QTMEDIDAINIVARIACAO,
                                      QTMEDIDAFIMVARIACAO, QTFRANQUIA, VRPRECOVARIACAO, IDMULTIPVARIACAO, NRORG
                                  FROM FCT_VARPRECBASESERVORCA
                                 WHERE NRSEQORCAMENTO = P_NRSEQORCAMENTO
                                   AND NRORG          = P_NRORG ) LOOP

                NOVO_CODIGO_NT('FCT_VARPRECBASESERVCONT', V_NRVARPRECBASESERVCONT, 1, P_NRORG);

                INSERT INTO FCT_VARPRECBASESERVCONT (NRVARPRECBASESERVCONT,
                                                     NRSEQCONTRATO,
                                                     CDSERVORCA,
                                                     CDTPMEDIDASERV,
                                                     CDTPMEDIDAVARIAVEL,
                                                     QTMEDIDAINIVARIACAO,
                                                     QTMEDIDAFIMVARIACAO,
                                                     QTFRANQUIA,
                                                     VRPRECOVARIACAO,
                                                     IDMULTIPVARIACAO,
                                                     NRORG,
                                                     IDATIVO,
                                                     DTINCLUSAO,
                                                     NRORGINCLUSAO,
                                                     CDOPERINCLUSAO)
                             VALUES (V_NRVARPRECBASESERVCONT,
                                     V_NRSEQCONTRATO,
                                     C_TABPRECO.CDSERVORCA,
                                     C_TABPRECO.CDTPMEDIDASERV,
                                     C_TABPRECO.CDTPMEDIDAVARIAVEL,
                                     C_TABPRECO.QTMEDIDAINIVARIACAO,
                                     C_TABPRECO.QTMEDIDAFIMVARIACAO,
                                     C_TABPRECO.QTFRANQUIA,
                                     C_TABPRECO.VRPRECOVARIACAO,
                                     C_TABPRECO.IDMULTIPVARIACAO,
                                     P_NRORG,
                                     'S',
                                     SYSDATE,
                                     P_NRORG,
                                     C_ORCAMENTO.CDOPERRESPONSAVEL);

            END LOOP;

        END IF;

        FOR C_COMPSERVICO IN(
            SELECT NRCOMPSERVICO,
                NMCOMPSERVICO,
                NRCOMPSERVICOPAI,
                IDCOMPOBRIGATORIA,
                IDESCOLHIDO
            FROM FCT_COMPSERVORCAMENTO
            WHERE NRSEQORCAMENTO    = P_NRSEQORCAMENTO
                AND NRORG           = P_NRORG
        ) LOOP
            NOVO_CODIGO_NT('FCT_COMPSERVCONTRATO', V_NRCOMPSERVCONT, 1, P_NRORG);
            INSERT INTO FCT_COMPSERVCONTRATO (
                NRCOMPSERVCONT,
                NRSEQCONTRATO,
                NRCOMPSERVICO,
                NMCOMPSERVICO,
                NRCOMPSERVICOPAI,
                IDCOMPOBRIGATORIA,
                IDESCOLHIDO,
                NRORG,
                IDATIVO,
                DTINCLUSAO,
                DTULTATU,
                NRORGINCLUSAO,
                CDOPERINCLUSAO,
                NRORGULTATU,
                CDOPERULTATU
            ) VALUES (
                V_NRCOMPSERVCONT,
                V_NRSEQCONTRATO,
                C_COMPSERVICO.NRCOMPSERVICO,
                C_COMPSERVICO.NMCOMPSERVICO,
                C_COMPSERVICO.NRCOMPSERVICOPAI,
                C_COMPSERVICO.IDCOMPOBRIGATORIA,
                C_COMPSERVICO.IDESCOLHIDO,
                P_NRORG,
                'S',
                SYSDATE,
                NULL,
                P_NRORG,
                C_ORCAMENTO.CDOPERRESPONSAVEL,
                NULL,
                NULL
            );
        END LOOP; -- C_COMPSERVICO

        IF V_NRSEQMODCONTRATO IS NOT NULL THEN
          NOVO_CODIGO_NT('FCT_REFEORCACONT', V_NRSEQREFEORCCONT,1);
          INSERT INTO FCT_REFEORCACONT
            (NRSEQREFEORCCONT,  NRSEQORCAMENTO,   NRSEQCONTRATO, IDCONTRATIVO,
             NRORG, DTINCLUSAO, NRTIPOORCAMENTO, IDATIVO)
          VALUES
            (V_NRSEQREFEORCCONT, P_NRSEQORCAMENTO, V_NRSEQCONTRATO,'A',
             P_NRORG,            SYSDATE,          C_ORCAMENTO.NRTIPOORCAMENTO,
             'S');
      END IF;
    END LOOP;
    P_NRSEQCONTRATO := V_NRSEQCONTRATO;
END;
/